%define anolis_release 1

Name:		rtkit
Epoch:		1
Version:	0.11
Release:	%{anolis_release}%{?dist}
Summary:	Realtime Policy and Watchdog Daemon

License:	GPLv3+ and BSD
URL:		http://git.0pointer.net/rtkit.git/
Source0:	https://0pointer.de/public/rtkit-0.11.tar.xz

BuildRequires:  make
BuildRequires:  systemd-devel
BuildRequires:  dbus-devel >= 1.2
BuildRequires:  libcap-devel
BuildRequires:  polkit-devel
BuildRequires:  autoconf automake libtool
Requires:	dbus
Requires:       polkit

Patch0:         0000-rtkit-mq_getattr.patch
Patch1:         0001-SECURITY-Pass-uid-of-caller-to-polkit.patch
Patch2:         0002-rtkit-controlgroup.patch
# Temporarily disable -Werror=format-security since it breaks the build
Patch3:         0003-format-security.patch
 
Patch4:         0004-Fix-borked-error-check.patch
Patch5:         0005-systemd-update-sd-daemon.-ch.patch
Patch6:         0006-Remove-bundled-copy-of-sd-daemon.-ch.patch

%description
RealtimeKit is a D-Bus system service that changes the
scheduling policy of user processes/threads to SCHED_RR (i.e. realtime
scheduling mode) on request. It is intended to be used as a secure
mechanism to allow real-time scheduling to be used by normal user
processes.
 
%prep
%autosetup -n %{name}-%{version} -p1

%build
autoreconf -fvi
%configure --with-systemdsystemunitdir=%{_unitdir}
%make_build
./rtkit-daemon --introspect > org.freedesktop.RealtimeKit1.xml

%install
%make_install
install -Dm0644 org.freedesktop.RealtimeKit1.xml %{buildroot}%{_datadir}/dbus-1/interfaces/org.freedesktop.RealtimeKit1.xml

%pre
getent group rtkit >/dev/null 2>&1 || groupadd \
        -r \
        -g 172 \
        rtkit
getent passwd rtkit >/dev/null 2>&1 || useradd \
        -r -l \
        -u 172 \
        -g rtkit \
        -d /proc \
        -s /sbin/nologin \
        -c "RealtimeKit" \
        rtkit
:;
 
%post
%systemd_post rtkit-daemon.service
dbus-send --system --type=method_call --dest=org.freedesktop.DBus / org.freedesktop.DBus.ReloadConfig >/dev/null 2>&1 || :
 
%preun
%systemd_preun rtkit-daemon.service
 
%postun
%systemd_postun_with_restart rtkit-daemon.service

%files
%license GPL LICENSE
%doc README rtkit.c rtkit.h
%attr(0755,root,root) %{_sbindir}/rtkitctl
%attr(0755,root,root) %{_libexecdir}/rtkit-daemon
%{_datadir}/dbus-1/system-services/org.freedesktop.RealtimeKit1.service
%{_datadir}/dbus-1/interfaces/org.freedesktop.RealtimeKit1.xml
%{_datadir}/polkit-1/actions/org.freedesktop.RealtimeKit1.policy
%config(noreplace) %{_sysconfdir}/dbus-1/system.d/org.freedesktop.RealtimeKit1.conf
%{_prefix}/lib/systemd/system/rtkit-daemon.service
%{_mandir}/man8/*

%changelog
* Fri Apr 15 2022 happy_orange <songnannan@linux.alibaba.com> - 1:0.11-1
- Init package from upstream
